<?php
/*
Plugin Name: RSS Pages For Wordpress v3+
Plugin URI: http://www.thepicklingjar.com/code/rss-pages-for-wordpress-v3/
Description: Display wordpress pages in a rss feed, just enable as the headers are already added
Author: The Pickling Jar Ltd
Version: 2.4.0
Author URI: http://www.thepicklingjar.com/
*/

function feed_rss2_pages($comments = "") {
	header('Content-Type: text/xml; charset=' . get_option('blog_charset'), true);
	echo '<?xml version="1.0" encoding="'.get_option('blog_charset').'"?'.'>'."\n";

	$bloginfo_rss_name = get_bloginfo_rss('name');
	$bloginfo_rss_description = get_bloginfo_rss('description');
	$bloginfo_rss_url = get_bloginfo_rss('url');
	$rss_language = get_option('rss_language');

	$p = wp_list_pages('title_li=&sort_column=post_modified&show_date=modified&echo=0');
	preg_match_all('/href="(.+)" title="(.+)">.+<\/a>(.+)<\/li>/U', $p, $matches);
	$c = count($matches[1]);
	for($i = $c; $i >= 0; $i--){
		if($i == $c){
			echo '<rss version="2.0"
	xmlns:content="http://purl.org/rss/1.0/modules/content/"
	xmlns:wfw="http://wellformedweb.org/CommentAPI/"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:atom="http://www.w3.org/2005/Atom"
	>
<channel>
	<title>'.$bloginfo_rss_name.' ';
	wp_title_rss();
	echo '</title>
	<atom:link href="'.self_link().'/" rel="self" type="application/rss+xml" />
	<link>'.$bloginfo_rss_url.'/</link>
	<description>'.$bloginfo_rss_description.'</description>
	<pubDate>'.mysql2date('D, d M Y H:i:s +0000', mktime($matches[3][$i]), false).'</pubDate>
	<generator>http://www.thepicklingjar.com/#rsspages</generator>
	<language>'.$rss_language.'</language>';
			do_action('rss2_head');
			echo '</channel>';
		}
		if($matches[1][$i] != ""){
			echo "<item>";
			echo "<title>";
			echo $matches[2][$i];
			echo "</title>";
			echo "<link>";
			echo $matches[1][$i];
			echo "</link>";
			echo '<guid isPermaLink="false">';
			echo $matches[1][$i];
			echo '</guid>';
			echo "<pubDate>";
				$tm=date("D, d M Y H:i:s",mktime($matches[3][$i]));
				$tm=$tm. " GMT";
				echo $tm;
			echo "</pubDate>";
			echo "<description><![CDATA[Please Visit <a href='".$matches[1][$i]."'>".$matches[2][$i]."</a> for the full update]]></description>";
			echo "<content:encoded><![CDATA[".$matches[2][$i]. "]]></content:encoded>";
			echo "</item>\n";
		}
	}
	echo '</rss>';
}

function feed_rss_pages($comments = ""){
	header('Content-Type: text/xml; charset=' . get_option('blog_charset'), true);
	echo '<?xml version="1.0" encoding="'.get_option('blog_charset').'"?'.'>';

	$bloginfo_rss_name = get_bloginfo_rss('name');
	//$wp_title_rss = wp_title_rss();
	$bloginfo_rss_url = get_bloginfo_rss('url');
	$rss_language = get_option('rss_language');
	$bloginfo_rss_description = get_bloginfo_rss('description');
	$p = wp_list_pages('title_li=&sort_column=post_modified&show_date=modified&echo=0');
	preg_match_all('/href="(.+)" title="(.+)">.+<\/a>(.+)<\/li>/U', $p, $matches);
	$c = count($matches[1]);
	for($i = $c; $i >= 0; $i--){
		if($i == $c){
			echo '<!-- generator="http://www.thepicklingjar.com/#rsspages" -->
<rss version="0.92">
<channel>
        <title>'.$bloginfo_rss_name.' ';
	wp_title_rss();
	echo '</title>
        <link>'.$bloginfo_rss_url.'</link>
        <description>'.$bloginfo_rss_description.'</description>
        <lastBuildDate>'.mysql2date('D, d M Y H:i:s +0000', mktime(trim($matches[3][$i])), false).'</lastBuildDate>
        <docs>http://backend.userland.com/rss092</docs>
        <language>'.$rss_language.'</language>';
		        do_action('rss_head');
		}
		if($matches[1][$i] != ""){
        		echo "<item>";
			echo "<title>";
			echo $matches[2][$i];
			echo "</title>";
			echo "<description><![CDATA[Please Visit <a href='".$matches[1][$i]."'>".$matches[2][$i]."</a> for the full update]]></description>";
			echo "<link>";
			echo $matches[1][$i];
			echo "</link>";
                	do_action('rss_item');
			echo "</item>\n";
		}
	}
	echo '</channel>';
	echo '</rss>';
}

function feed_atom_pages($comments = ""){
	header('Content-Type: application/atom+xml; charset=' . get_option('blog_charset'), true);
	echo '<?xml version="1.0" encoding="'.get_option('blog_charset').'"?'.'>';

        $bloginfo_rss_name = get_bloginfo_rss('name');
        $bloginfo_rss_home = home_url();
        $bloginfo_rss_url = get_bloginfo_rss('url');
        $rss_language = get_option('rss_language');
        $bloginfo_rss_description = get_bloginfo_rss('description');

	$p = wp_list_pages("title_li=&sort_column=post_modified&show_date=modified&echo=0&date_format=H\:i\:s d/F/Y");
	$q = wp_list_pages("title_li=&sort_column=post_modified&show_date=created&echo=0&date_format=H\:i\:s d/F/Y");
	preg_match_all('/href="(.+)" title="(.+)">.+<\/a>(.+)<\/li>/U', $p, $matches);
	preg_match_all('/href="(.+)" title="(.+)">.+<\/a>(.+)<\/li>/U', $q, $matchesa);
	$c = count($matches[1]);
	for($i = $c; $i >= 0; $i--){
		if($i == $c){
			echo '<feed
  xmlns="http://www.w3.org/2005/Atom"
  xmlns:thr="http://purl.org/syndication/thread/1.0"
  xml:lang="'.$rss_language.'"
  xml:base="'.$bloginfo_rss_home.'/?feed=pages-atom"';
			do_action('atom_ns');
			echo '>
        <title type="text">'.$bloginfo_rss_name.' ';
	wp_title_rss();
	echo '</title>
        <subtitle type="text">'.$bloginfo_rss_description.'</subtitle>
        <updated>'.mysql2date('Y-m-d\TH:i:s\Z', mktime($matches[3][$i)).'</updated>
        <generator>http://www.thepicklingjar.com/#rsspages</generator>
        <link rel="alternate" type="text/html" href="'.$bloginfo_rss_home.'" />
	<id>'.$bloginfo_rss_home.'/?feed=atom_pages</id>
        <link rel="self" type="application/atom+xml" href="'.self_link().'" />';
			do_action('atom_head');
		}
		if($matches[1][$i] != ""){
        		echo "<entry>";
		        echo "<author>";
                        echo "<name>";
			echo $bloginfo_rss_name;
			echo "</name>";
                        echo "<uri>";
			echo $bloginfo_rss_home;
			echo "</uri>";
	                echo "</author>";
			?>
	                <title type="<?php html_type_rss(); ?>"><![CDATA[<?php echo $matches[2][$i]; ?>]]></title>
        	        <link rel="alternate" type="text/html" href="<?php echo $matches[1][$i]; ?>" />
                	<id><?php echo $matches[1][$i]; ?></id>
	                <updated><?php echo date("Y-m-d\TH:i:s\Z", mktime($matches[3][$i])); ?></updated>
	                <published><?php echo date("Y-m-d\TH:i:s\Z", mktime($matchesa[3][$i])); ?></published>
                	<?php the_category_rss('atom') ?>
	                <summary type="<?php html_type_rss(); ?>"><![CDATA[Please Visit <a href='<?php echo $matches[1][$i];?>'><?php echo $matches[2][$i];?></a> for the full update]]></summary>
        	        <content type="<?php html_type_rss(); ?>" xml:base="<?php echo $matches[1][$i]; ?>"><![CDATA[Please Visit <a href='<?php echo $matches[1][$i];?>'><?php echo $matches[2][$i];?></a> for the full update]]></content>
			<?php do_action('atom_entry'); ?>
		        </entry>
			<?php
		}
	}
	echo '</feed>';
}


function add_rss_pages() {
add_feed('pages-rss','feed_rss_pages');
add_feed('pages-rss2','feed_rss2_pages');
add_feed('pages-atom','feed_atom_pages');
}
function add_rss_pages_to_header(){
	echo '<link rel="alternate" type="application/rss+xml" title="'.get_bloginfo('name').' Pages Rss Feed" href="'.get_bloginfo('wpurl').'/?feed=pages-rss" />'."\n";
	echo '<link rel="alternate" type="application/rss+xml" title="'.get_bloginfo('name').' Pages Rss2 Feed" href="'.get_bloginfo('wpurl').'/?feed=pages-rss2" />'."\n";
	echo '<link rel="alternate" type="application/atom+xml" title="'.get_bloginfo('name').' Pages Atom Feed" href="'.get_bloginfo('wpurl').'/?feed=pages-atom" />'."\n";
}
add_action('init','add_rss_pages',10,1);
add_action('wp_head','add_rss_pages_to_header');
?>
